﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=9.8
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Private am As AmazonMessaging
	Private adm As ADM
	Dim Broadcast As BroadCastReceiver

End Sub
Sub Service_Create
	Broadcast.Initialize("BroadcastReceiver")
	am.Initialize("am")
	adm.Initialize("ADM")
End Sub
Public Sub Register
	If adm.IS_ADM_AVAILABLE Then
		If adm.IS_ADM_V2 Then
			Log("ADM V2 supported on this Device!")
		Else
			Log("ADM supported on this Device!")
		End If
		
		Log("Check Manifest")
		'adm.checkManifestAuthoredProperly
		
		Log("Calling startRegister")
		StartRegister
	Else
		Log("ADM not supported on this Device!")
	End If
End Sub
Public Sub GetToken() As String
	If adm.Supported Then
		If adm.RegistrationId = Null Then
			adm.startRegister ' At latest i expect it to crash here if we came such far
		Else
			Return adm.RegistrationId
		End If
	End If
	Return ""
End Sub

public Sub StartRegister()
	Log("StartRegister()")
	If adm.Supported Then
		Log("ADM 2nd check: ADM supported on this Device!")
		Log($"RegistrationId = ${adm.RegistrationId}"$)
		'adm.startRegister ' At latest i expect it to crash here if we came such far
		If adm.RegistrationId = Null Then
			adm.startRegister ' At latest i expect it to crash here if we came such far
		Else
			Log($"RegistrationId = ${adm.RegistrationId}"$)
			Log($"Send the RegistrationId to your Server to track the users RegistrationId (this apps instance)"$)

		End If
		
	End If
End Sub
Sub Service_Start (StartingIntent As Intent)
	If StartingIntent <> Null Then
		Log(StartingIntent)
		Log(StartingIntent.Action)
		Log(StartingIntent.ExtrasToString)
	End If
	Broadcast.addAction("com.amazon.device.messaging.intent.REGISTRATION")
	Broadcast.addAction("com.amazon.device.messaging.intent.RECEIVE")
	Broadcast.addCategory(Application.PackageName)
	Broadcast.SetPriority(2147483647)
	Broadcast.registerReceiver("")
	Service.StopAutomaticForeground 'Call this when the background task completes (if there is one)
End Sub
Sub BroadcastReceiver_OnReceive (Action As String)
	ToastMessageShow(Action,False)
	Log("AmazonBCR:Action = "&Action)
	'can only abort when sendOrderedbroadcast is called.
	'Broadcast.AbortBroadcast
End Sub


Sub Service_Destroy

End Sub
